projeto01/agenda/urls.py
from django.urls import path
from . import views

# adicionar um 'app_name'
app_name = "agenda"


urlpatterns = [
    path('', views.lista_contato, name='lista'),
    path('cadastrar/', views.novo_contato, name='cadastrar'),
    path('editar_cadastro/<int:pk>/', views.editar_contato, name='editar_contato'),
    path('excluir_contato/<int:pk>/', views.deletar_contato, name='deletar_contato'),
    
]

projeto01/urls.py
from django.contrib import admin
from django.urls import path, include
from .core import views

from .agenda import urls as agenda_urls

from django.conf.urls.static import static
# Para servir os CSS e JS localmente
from django.conf import settings



urlpatterns = [
    path('', views.home, name="home"),
    path('mapa/', views.home_mapa, name="home_mapa"),
    path('registro/', views.registro, name="registro"),
    path('logout/', views.user_logout, name='logout'),
    path('conta-criada/', views.msg_conta_criada, name='msg_conta_criada'),
    path('accounts/', include('django.contrib.auth.urls')),
    path('agenda/', include(agenda_urls, namespace='agenda')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls', namespace='rest_framework'))

]


# Configurando os arquivos estáticos a serem usandos na aplicação(CSS e JavaScripts localmente)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

projeto01/agenda/models.py
from django.db import models
from django.contrib.auth.models import User


class Cadastro(models.Model):
    nome = models.CharField(max_length=100, verbose_name="Nome")
    email = models.EmailField(verbose_name="E-mail")
    endereco = models.CharField(max_length=255, verbose_name="Endereço")
    cargo = models.CharField(max_length=100, verbose_name="Cargo")
    celular = models.CharField(max_length=9, verbose_name="Celular")
    telefone = models.CharField(max_length=9, verbose_name="Tel.Fixo")
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    SEXO = (
        ('Masculino', 'Masculino'),
        ('Feminino', 'Feminino'),
    )
    sexo = models.CharField(max_length=10, choices=SEXO)

    def __str__(self):
        return self.nome

projeto01/core/models.py
from django.db import models


# Criar os modelos aqui

projeto01/agenda/forms.py
from django import forms
from .models import Cadastro

class CadastroForm(forms.ModelForm):
    class Meta:
        # Pega os dados do MODELO
        model = Cadastro
        # Usa todos os campos
        fields = '__all__'
        # Faz com que não seja usado o campo 'user' Usuário
        exclude = ['user']
        widgets = {'nome': forms.TextInput(attrs={'class': 'form-control', 'type': 'text', 'placeholder': 'Nome'}),
                   'email': forms.EmailInput(attrs={'class': 'form-control', 'type': 'email', 'placeholder': 'E-mail'}),
                   'endereco': forms.TextInput(attrs={'class': 'form-control', 'type': 'text', 'placeholder': 'Endereço'}),
                   'cargo': forms.TextInput(attrs={'class': 'form-control', 'type': 'text', 'placeholder': 'Cargo'}),
                   'celular': forms.TextInput(attrs={'class': 'form-control', 'type': 'tel', 'placeholder': 'Celular'}),
                   'telefone': forms.NumberInput(attrs={'class': 'form-control', 'type': 'number', 'placeholder': 'Telefone'}),
                   'sexo': forms.Select(attrs={'class': 'form-control', 'type': 'text', 'placeholder': 'Sexo'})}

projeto01/core/forms.py
from django.contrib.auth.models import User
from django import forms
from django.contrib.auth.forms import UserChangeForm, UserCreationForm

class UserForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ('first_name', 'last_name', 'email', 'username', 'password')
        widgets = {'first_name': forms.TextInput(attrs={'class': 'form-control', 'type': 'text', 'placeholder': 'Nome'}),
                   'last_name': forms.TextInput(attrs={'class': 'form-control', 'type': 'text', 'placeholder': 'Sobrenome'}),
                   'email': forms.EmailInput(attrs={'class': 'form-control', 'type': 'email', 'placeholder': 'E-mail'}),
                   'username': forms.TextInput(attrs={'class': 'form-control', 'type': 'text', 'placeholder': 'Usuário'}),
                   'password': forms.PasswordInput(attrs={'class': 'form-control line-input', 'placeholder': 'Senha'})}


class CustomUserChangeForm(UserChangeForm):
    class Meta:
        model = User
        fields = '__all__'

projeto01/agenda/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.contrib.auth.models import User
from django.contrib import messages

# Importando o Forms e os Modelos
from .forms import CadastroForm
from .models import Cadastro


# Criar uma função para listar todos os contatos
@login_required
def lista_contato(request):
    name_template = "agenda/cadastro_list.html"
    cadastro = Cadastro.objects.filter(user=request.user)
    return render(request, name_template, {'cadastro': cadastro})


@login_required
def editar_contato(request, pk):
    nome_template = "agenda/cadastro_form.html"
    contato = get_object_or_404(Cadastro, id=pk, user=request.user)
    if request.method == 'POST':
        form = CadastroForm(request.POST, instance=contato)
        if form.is_valid():
            form.save()
            return redirect('agenda:lista')
    else:
        form = CadastroForm(instance=contato)
    return render(request, nome_template, {'form': form})


# Criar a função que irá deletar/excluir um contato
@login_required
def deletar_contato(request, pk):
    nome_redirect = 'agenda:lista'
    nome_template = "agenda/cadastro_list.html"
    contato = Cadastro.objects.get(id=pk)
    if contato.user == request.user:
        contato.delete()
    else:
        messages.error(request, 'Você não tem permissão para excluir este contato')
        return render(request, nome_template)
    return redirect(nome_redirect)



@login_required
def novo_contato(request):
    nome_template = "agenda/cadastro_form.html"
    if request.method == 'POST':
        formulario = CadastroForm(request.POST)
        if formulario.is_valid():
            f = formulario.save(commit=False)
            f.user = request.user
            f.save()
            return redirect('agenda:lista')
        else:
            print(formulario.errors)
    else:
        formulario = CadastroForm()
    return render(request, nome_template, {'form': formulario})

projeto01/core/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from django.contrib.auth import logout
from .forms import UserForm


# Função criada para mostrar quantos usuários está cadastrados na aplicação
def home(request):
    conta = User.objects.count()
    return render(request, 'home.html', {'conta': conta})


def home_mapa(request):
    return render(request, 'agenda/mapeamento.html')


# Função criada que irá fazer o LOGOUT na aplicação
def user_logout(request):
    logout(request)
    return redirect('login')


# Função criada que irá fazer o LOGOUT na aplicação
def msg_conta_criada(request):
    nome_template = 'registration/conta_criada_sucesso.html'
    form = UserForm()
    return render(request, nome_template, {'form': form})


# Criando a função que irá CADASTRAR/REGISTRAR usuário na aplicação
def registro(request):
    nome_template = 'registration/registro.html'
    if request.method == "POST":
        form = UserForm(request.POST)
        if form.is_valid():
            u = form.save()
            u.set_password(u.password)
            u.save()
            return redirect('msg_conta_criada')
    else:
        form = UserForm()
    return render(request, nome_template, {'form': form})

projeto01/templates/agenda/cadastro_form.html
{% extends 'base.html' %}


{% load crispy_forms_tags %}

{% block titulo %}
  Adicionar contato
{% endblock titulo %}

{% block conteudo %}


<div class="container">

    <div class="row">

        <aside class="col-sm-10">

                    <h5 class="card-title text-left mb-4 mt-1">Adicionar contato</h5>
                    <hr>
                    <p class="text-success text-left">Preencha os campos abaixo para cadastrar um novo contato.</p>


                    <form method="post" novalidate>

                        {% csrf_token %}

                        <div class="form-row">
                            <div class="form-group col-md-6">
                                 {{ form.nome|as_crispy_field }}
                            </div>
                            <div class="form-group col-md-6">
                                {{ form.email|as_crispy_field }}
                            </div>
                        </div>

                         <div class="form-row">
                            <div class="form-group col-md-6">
                                  {{ form.endereco|as_crispy_field }}
                            </div>
                            <div class="form-group col-md-6">
                                {{ form.cargo|as_crispy_field }}
                            </div>
                        </div>


                        <div class="form-row">
                            <div class="form-group col-md-6">
                                  {{ form.celular|as_crispy_field }}
                            </div>
                            <div class="form-group col-md-6">
                                {{ form.telefone|as_crispy_field }}
                            </div>
                        </div>

                         <div class="form-group">
                            {{ form.sexo|as_crispy_field }}
                        </div>

                     <button type="submit" class="btn btn-primary">Salvar</button>

                    </form>
        </aside>
    </div>
</div>

<br/>

{% endblock conteudo %}

projeto01/templates/agenda/cadastro_list.html
{% extends 'base.html' %}

{% block titulo %}
  Lista da Agenda
{% endblock titulo %}

{% block conteudo %}

<div class="container">



    <h5 class="card-title text-left mb-4 mt-1">Lista de contatos</h5>
	<hr>


    {% if messages %}
    {% for msg in messages %}
    <div class="alert alert-danger">
        {{ msg }}
    </div>
    {% endfor %}
    {% endif %}

    <!-- Se houver contato adicionado, exiba abaixo -->
    {% if cadastro %}


   <!-- Torna a Tabela Responsiva(table-responsive) -->
    <div class="table-responsive-sm">

        <table class="table table-striped table-bordered table-hover table-sm">

            <thead >
                <tr>
                    <th scope="col">Nome</th>
                    <th scope="col">E-mail</th>
                    <th scope="col">Endereço</th>
                    <th scope="col">Cargo</th>
                    <th scope="col">Celular</th>
                    <th scope="col">Telefone</th>
                    <th scope="col" style="text-align:center">Sexo</th>
                    <th colspan="2" style="text-align:center">Ações</th>
                </tr>
            </thead>


            <tbody>

                {% for c in cadastro %}

                <tr scope="row">
                    <td>{{ c.nome }}</td>
                    <td>{{ c.email }}</td>
                    <td>{{ c.endereco }}</td>
                    <td>{{ c.cargo }}</td>
                    <td>{{ c.celular }}</td>
                    <td>{{ c.telefone }}</td>
                    <td>{{ c.sexo }}</td>
                    <td style="text-align:center"><a href="{% url 'agenda:editar_contato' c.id %}" class="btn btn-info btn-xs">Editar</a></td>
                    <td style="text-align:center"><a href="{% url 'agenda:deletar_contato' c.id %}" class="btn btn-danger btn-xs">Excluir</a></td>
                </tr>

                {% endfor %}

            </tbody>
        </table>

        <!-- Se não cai aqui -->
        {% else %}
        <div class="text-center mt-5 mb-5 jumbotron">
            <h5>Não há <code>contato</code> adicionado...</h5>
        </div>

        {% endif %}


       <a href="{% url 'agenda:cadastrar' %}" class="btn btn-primary" role="button">Adicionar</a>

    </div>


</div>


{% endblock conteudo %}

projeto01/templates/agenda/mapeamento.html
{% extends 'base_mapa.html' %}


{% block titulo %}
   Mapeamento
{% endblock titulo %}

{% block conteudo %}

<div class="container">

</div>

{% endblock conteudo %}

projeto01/templates/base.html
{% load staticfiles %}

<!DOCTYPE html>
<html lang="pt-BR">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

   <link rel="stylesheet" 
   href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
   integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">

<title>{% block titulo %} MobDrive {% endblock %} </title>

     <style type="text/css">

    .asteriskField {
      display: none;
    }
    form .alert ul li {
      list-style: none;
    }
    form .alert ul {
      padding: 0;
      margin: 0;
    }
    .btn-entrar {
      color: #000000;
      background: #f89d38;
      border-radius: 4px;
      letter-spacing: 1px;
      display: inline-block;
    }
    .btn-warning {
      color: #ffff;
      background: #f89d38;
      border-radius: 4px;
      letter-spacing: 1px;
      display: inline-block;
    }
    .btn-warning-login {
      color: #fff;
      background: #f89d38;
      border-radius: 40px;
    }
    .btn-warning-login:hover{
     background: #f89d38;
     color: #fff;
     box-shadow: inset 0 0 0 3px #ffff;
    .navbar{
      background: #212529;
    }
}
</style>

  </head>

  <body>

  <nav class="navbar navbar-expand-lg navbar-dark bg-dark mb-4">

  <div class="container">

  <a class="navbar-brand" href="{% url 'home' %}">
    <img  src="{% static 'img/logoMobdrive.png' %}"  width="160px" height="34px" alt="MobDrive" title="MobDrive" style="margin-top:-14px;">
  </a>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
          aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>


  <div class="collapse navbar-collapse" id="navbarSupportedContent">

       <ul class="navbar-nav mr-auto">

          {% if user.is_authenticated %}

          <li class="nav-item">
              <a class="nav-link" href="{% url 'agenda:lista' %}">Agenda</a>
          </li>

           <li class="nav-item">
              <a class="nav-link" href="{% url 'home_mapa' %}">Mapa Dinâmico</a>
          </li>

          {% endif %}

        </ul>


     {% if user.is_authenticated %}

       <ul class="navbar-nav">

      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
           {{ user.get_full_name }} <!-- Retorna somente o primeiro nome 'first name' -->
            <!-- {{ user.username }} -->
            <!-- {{ user.get_full_name }} Retorna o primeiro nome(first name) e último nome(last name) -->
        </a>
        <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="{% url 'password_change' %}">Alterar senha</a>
          <div class="dropdown-divider"></div>
          <a class="dropdown-item" href="{% url 'logout' %}">Sair</a>
        </div>
      </li>

      </ul>

      {% else %}

     <form class="form-inline my-2 my-lg-0">
         <a href="{% url 'login' %}" class="btn btn-outline-light"><strong>Entrar</strong></a>
         <a href="{% url 'registro' %}" class="btn btn-warning ml-2"><strong>Registro</strong></a>
    </form>

      {% endif %}

   </div>

 </div>

</nav>


  <div class="container">
  {% block conteudo %}

  {% endblock conteudo %}

  </div>


<!-- Utilizando a parte do JavaScript no caminho do Path -->
<script src="{% static 'js/mapa.js' %}"></script>

<script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
  
  </body>
</html>

projeto01/templates/base_mapa.html
{% load staticfiles %}

<!DOCTYPE html>
<html lang="pt-BR">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

 <link rel="stylesheet" 
     href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
         integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">

<script src='https://api.mapbox.com/mapbox-gl-js/v0.51.0/mapbox-gl.js'></script>
<link href='https://api.mapbox.com/mapbox-gl-js/v0.51.0/mapbox-gl.css' rel='stylesheet' />

<!-- adicionando o Geocoder -->
<script src='https://api.mapbox.com/mapbox-gl-js/plugins/mapbox-gl-geocoder/v2.3.0/mapbox-gl-geocoder.min.js'></script>
<link rel='stylesheet' href='https://api.mapbox.com/mapbox-gl-js/plugins/mapbox-gl-geocoder/v2.3.0/mapbox-gl-geocoder.css' type='text/css' />

<!-- Importando o CSS da pasta STATIC -->
<link rel="stylesheet" type="text/css" href="{% static 'css/mapbox-gl-draw.css' %}">

<title>Mapa Dinâmico</title>
<style type="text/css">
*{ 
margin: 0; 
padding: 0; 
}    
html, 
body, 
#map{
  width: 100%;
  height: 100%;
  margin:0px;
}
   
</style>

</head>
<body>


<nav class="navbar navbar-expand-lg navbar-dark bg-dark mb-0">

  <div class="container">

  <a class="navbar-brand" href="{% url 'home' %}">
    <img  src="{% static 'img/logoMobdrive.png' %}"  width="160px" height="34px" alt="MobDrive" title="MobDrive" style="margin-top:-14px;">
  </a>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
          aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>


  <div class="collapse navbar-collapse" id="navbarSupportedContent">

       <ul class="navbar-nav mr-auto">

          {% if user.is_authenticated %}

          <li class="nav-item">
              <a class="nav-link" href="{% url 'agenda:lista' %}">Agenda</a>
          </li>

           <li class="nav-item">
              <a class="nav-link" href="{% url 'home_mapa' %}">Mapa Dinâmico</a>
          </li>

          {% endif %}

        </ul>


     {% if user.is_authenticated %}

       <ul class="navbar-nav">

      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          {{ user.get_full_name }} <!-- Retorna somente o primeiro nome 'first name' -->
            <!-- {{ user.username }} -->
            <!-- {{ user.get_full_name }} Retorna o primeiro nome(first name) e último nome(last name) -->
        </a>
        <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="{% url 'password_change' %}">Alterar senha</a>
          <div class="dropdown-divider"></div>
          <a class="dropdown-item" href="{% url 'logout' %}">Sair</a>
        </div>
      </li>

      </ul>
  
      {% else %}

     <form class="form-inline my-2 my-lg-0">
         <a href="{% url 'login' %}" class="btn btn-outline-light"><strong>Entrar</strong></a>
         <a href="{% url 'registro' %}" class="btn btn-warning ml-2"><strong>Registro</strong></a>
    </form>

      {% endif %}

   </div>

 </div>

</nav>



<!-- Exibindo o mapa na página -->
<div id='map'></div>

<!-- Utilizando a parte do JavaScript no caminho do Path -->
<script src="{% static 'js/mapa.js' %}"></script>

<script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>


 </body>
</html>

projeto01/templates/home.html
{% extends 'base.html' %}

{% block titulo %}
   Página Inicial
{% endblock titulo %}



{% block conteudo %}


<h1>Página home</h1>

<p>Seja bem-vindo(a),


{% if user.is_authenticated %}

{{ user.get_short_name.upper }} <!-- Retorna o primeiro nome(first name) -->
<!-- {{ user.first_name.upper }} -->

<p>
    <strong>Total de usuários registrados no sistema: </strong> {{ conta }}
</p>

{% else %}

amigo visitante.

{% endif %}

</p>


{% endblock conteudo%}